package sv.server.filter;

public class IsoFilter {

  /**
   * execute filter with given threshold
   * @param path cache file
   * @param xsize x dimension
   * @param ysize y dimension
   * @param zsize z dimension
   * @param threshold threshold to be executed
   * @param grid grid data
   * @return 0 if success, -1 otherwise
   */ 
  public static native int executeFilter(String path, 
                                 int xsize, int ysize, int zsize, 
                                 float threshold, float[] grid);
  static {
    System.loadLibrary("IsoFilter");
  }

} // end of class


