#include <jni.h>
#include "IsoFilter.h"
#include <stdio.h>

JNIEXPORT void JNICALL Java_IsoFilter_executeFilter
(JNIEnv *env, jclass clazz) {
  int num_int;
  int num_float;
  int test_int1[10];
  float test_float2[3][20];
  float test_float3[3][20];

  int i;

  jintArray newIntArray1;
  jfloatArray* newFloatArray2;
  jfloatArray* newFloatArray3;

  newIntArray1 = (*env)->NewIntArray(env, 10);

  /**
  *newFloatArray2 = &(*env)->NewFloatArray(env, 3);
  *newFloatArray3 = &(*env)->NewFloatArray(env, 3);
  for ( i = 0 ; i < 3 ; i++ ) {
    newFloatArray2[i] = (*env)->NewFloatArray(env, 10);
    newFloatArray3[i] = (*env)->NewFloatArray(env, 10);
  }
  **/

  num_int = 10;
  num_float = 20;

  for ( i = 0 ; i < num_int ; i++ ) {
    test_int1[i] = i;
  }

  for ( i = 0 ; i < num_float ; i++ ) {
    test_float2[0][i] = (float)(i * 1.0);
    test_float2[1][i] = (float)(i * 2.0);
    test_float2[2][i] = (float)(i * 3.0);

    test_float3[0][i] = (float)(i * 10.0);
    test_float3[1][i] = (float)(i * 20.0);
    test_float3[2][i] = (float)(i * 30.0);
  }

  jmethodID mid = (*env)->GetMethodID(env, clazz, "callback", "(II[I)V");
  if (mid == 0 ) {
    return;
  }

  /**
  (*env)->CallVoidMethod(env, clazz, mid, (jint)num_int, (jint)num_float, test_int1, test_float2, test_float3);
  **/

  (*env)->SetIntArrayRegion(env, newIntArray1, 0, num_int, (jint*)test_int1);


  (*env)->CallVoidMethod(env, , mid, (jint)num_int, (jint)num_float, newIntArray1);

}
