import java.io.*;
import java.net.*;
import java.util.*;

public class SendChannel {
    
    boolean DEBUG = true;

  int numInt;
  int numFloat;
  int[] intArray;
  float[] floatArray20;
  float[] floatArray21;
  float[] floatArray22;
  float[] floatArray30;
  float[] floatArray31;
  float[] floatArray32;

  boolean getData = false;

    public SendChannel() {
    }

    public void marchingCube() {
	TimeData3D timeData = new TimeData3D(this);
	timeData.marchingCube();
    }

    // send the isosurface data to a client
    private void sendIsoDataSet() {
      int i;

      while ( !getData ) {
	System.out.println("<SendChannel.java> waiting for the data");
      }

      System.out.println("<SendChannel.java> no of integer : " + numInt);
      System.out.println("<SendChannel.java> no of float   : " + numFloat);

      for ( i = 0 ; i < numInt ; i++ ) {
	System.out.println("<SendChannel.java> intArray[" + i + "] : " + intArray[i]);
      }

      for ( i = 0 ; i < numFloat ; i++ ) {
	System.out.println("<SendChannel.java> floatArray20[" + i + "] : " + floatArray20[i]);
	System.out.println("<SendChannel.java> floatArray21[" + i + "] : " + floatArray21[i]);
	System.out.println("<SendChannel.java> floatArray22[" + i + "] : " + floatArray22[i]);
	System.out.println("<SendChannel.java> --------------------------------------------");
	System.out.println("<SendChannel.java> floatArray30[" + i + "] : " + floatArray30[i]);
	System.out.println("<SendChannel.java> floatArray31[" + i + "] : " + floatArray31[i]);
	System.out.println("<SendChannel.java> floatArray32[" + i + "] : " + floatArray32[i]);
	System.out.println("<SendChannel.java> ============================================");
      }
    }

  public void callback(int numInt, int numFloat,
		       int[] intArray,
		       float[] floatArray20, float[] floatArray21, float[] floatArray22,
		       float[] floatArray30, float[] floatArray31, float[] floatArray32) {

    System.out.println("<SendChannel.java/callback> no of integer : " + numInt);
    System.out.println("<SendChannel.java/callback> no of float   : " + numFloat);


    this.numInt = numInt;
    this.numFloat = numFloat;

    this.intArray = intArray;

    this.floatArray20 = floatArray20;
    this.floatArray21 = floatArray21;
    this.floatArray22 = floatArray22;

    this.floatArray30 = floatArray30;
    this.floatArray31 = floatArray31;
    this.floatArray32 = floatArray32;

    getData = true;

  }

    public static void main(String args[]) {
	boolean marchingDone;

	System.out.println("<SendChannel> start");
	SendChannel sendChannel = new SendChannel();
	sendChannel.marchingCube();
	sendChannel.sendIsoDataSet();

    }

} // end of class

