#include <stdio.h>
#include <jni.h>
#include "Callbacks.h"

JNIEXPORT jboolean JNICALL Java_Callbacks_nativeMethod
  (JNIEnv *env, jobject obj, jintArray testInt, jint dataSize)
{
  int data_size;
  int dataC[10000];
  int i;
  int depth;
  jboolean isCopy;
  jintArray tmpInt;

  jclass cls = (*env)->GetObjectClass(env, obj);
  jmethodID mid = (*env)->GetMethodID(env, cls, "callback", "(I)V");
  if (mid == 0) {
    return;
  }

  printf("In C, depth = %d, about to enter Java\n", depth);
  (*env)->CallVoidMethod(env, obj, mid, 5);
  printf("In C, depth = %d, back from Java\n", depth);

  mid = (*env)->GetMethodID(env, cls, "callback", "([II)V");
  if (mid == 0) {
    return;
  }


  for ( i = 0 ; i < dataSize ; i++ ) {
    dataC[i] = i;
  }


  tmpInt = (*env)->NewIntArray(env, dataSize);
  (*env)->SetIntArrayRegion(env, tmpInt, 0, dataSize, (jint*)dataC);

  printf("call the callback 2nd\n");



  (*env)->CallVoidMethod(env, obj, mid, tmpInt, dataSize);

  return 1;
}
