class Callbacks {

  int[] testInt = new int[10000];
  int arraySize;

  private native boolean nativeMethod(int[] testInt, int dataSize);
  private void callback(int depth) {
    if (depth < 5) {
      System.out.println("In Java, depth = " + depth + ", about to enter C");
      //nativeMethod(depth + 1);
      System.out.println("In Java, depth = " + depth + ", back from C");
    } else
      System.out.println("In Java, depth = " + depth + ", limit exceeded");
  }

  private void callback() {
	int i;
	int numInt = 10;
	System.out.println("In Java, dataSize = " + arraySize);
	for ( i = 0 ; i < arraySize ; i++ ) {
		System.out.println("testInt[" + i + "] : " + testInt[i]);
	}
  }

  private void callback(int[] dataC, int dataSize) {
	int i;
	System.out.println("In Java, dataSize = " + dataSize);
	for ( i = 0 ; i < dataSize ; i++ ) {
		System.out.println("dataC[" + i + "] : " + dataC[i]);
	}
  }

  private void callback(int numInt, int[] dataC, float[][] floatData) {
	int i;
	System.out.println("In Java, dataSize = " + numInt);
	for ( i = 0 ; i < numInt ; i++ ) {
		System.out.println("dataC[" + i + "] : " + dataC[i]);
	}
  }

  public static void main(String args[]) {
    int i;

    Callbacks c = new Callbacks();

    c.arraySize = 10000;
    for ( i = 0 ; i < c.arraySize ; i++ ) {
      c.testInt[i] = 0;
    }

    //c.callback();
    if (c.nativeMethod(c.testInt, c.arraySize)) {
      // c.callback();
    }
  }
  static {
    System.loadLibrary("testSample2");
  }
}
