
Received: from postoffice.npac.syr.edu by lohengrin.top.cis.syr.edu id aa17555;
          20 Mar 96 2:12 EST
Received: from nova.npac.syr.edu (youngki@nova.npac.syr.edu [128.230.7.2]) by postoffice.npac.syr.edu (8.7.1/8.7.1) with ESMTP id CAA09895 for <youngki@top.cis.syr.edu>; Wed, 20 Mar 1996 02:12:36 -0500 (EST)
Received: (from youngki@localhost) by nova.npac.syr.edu (8.7.1/8.7.1) id CAA06004 for youngki@top.cis.syr.edu; Wed, 20 Mar 1996 02:12:34 -0500 (EST)
Date: Wed, 20 Mar 1996 02:12:34 -0500 (EST)
From: Young-ki Hwang <youngki@npac.syr.edu>
Message-Id: <199603200712.CAA06004@nova.npac.syr.edu>
To: youngki@top.cis.syr.edu
Status: O

From sypark@nova.npac.syr.edu Wed Mar 20 02:06 EST 1996
Received: from nova.npac.syr.edu (sypark@nova.npac.syr.edu [128.230.7.2]) by postoffice.npac.syr.edu (8.7.1/8.7.1) with ESMTP id CAA09864 for <youngki@npac.syr.edu>; Wed, 20 Mar 1996 02:06:03 -0500 (EST)
Received: (from sypark@localhost) by nova.npac.syr.edu (8.7.1/8.7.1) id CAA05958; Wed, 20 Mar 1996 02:06:02 -0500 (EST)
Date: Wed, 20 Mar 1996 02:06:01 -0500 (EST)
From: Sung-Yong Park <sypark@npac.syr.edu>
Subject: SOcket
To: Young-ki Hwang <youngki@nova.npac.syr.edu>
Message-ID: <Pine.3.89.9603200233.A5926-0100000@nova.npac.syr.edu>
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII
Content-Length: 8486
Status: O

\begin{verbatim}

/*
 *     Example of a connection-oriented server using TCP protocol.
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_TCP_PORT     7000
#define MAX_MSG_SIZE        2048

main()
{
     int sockfd, newsockfd, clilen, childpid, len;
     struct sockaddr_in  serv_addr, client_addr;
     char message[MAX_MSG_SIZE];

     /*
      * Open a TCP socket (an Internet stream socket).
      */

     if ( ( sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0 ) {
        fprintf(stderr, "server: can't open stream socket.");
        exit(1);
     }

     /*
      * Bind the local address of server.
      */

     bzero((char *) &serv_addr, sizeof(serv_addr));      /* Initialize      */
     serv_addr.sin_family      = AF_INET;                /* Internet family */
     serv_addr.sin_port        = htons(SERVER_TCP_PORT); /* Port number     */
     serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);      /* Netid / Hostid  */

     if ( bind(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0 ) {
        fprintf(stderr, "server: can't bind local address.");
        exit(1);
     }

     /*
      * Ready to receive connections. 
      * SOMAXCONN : Maximum queue length of pending requests for connections.
      */

     listen(sockfd, SOMAXCONN);

     /*
      * Wait for a connection from a client process.
      * This is an example of concurrent server.
      */

     while ( 1 ) {
        clilen = sizeof(client_addr);
        newsockfd = accept(sockfd, (struct sockaddr *) &client_addr, &clilen);
        if ( newsockfd < 0 ) {
           fprintf(stderr, "server: can't accept a connection.");
           exit(1);
        }
        if ( (childpid = fork()) < 0 ) {
           fprintf(stderr, "server: can't fork child process.");
           exit(1);
        }
        else if ( childpid == 0 ) { /* This is child process    */
           close(sockfd);           /* Close original socket    */

           /*
            * Do a specific task for the server.
            */

           if ( ( len = read(newsockfd, message, MAX_MSG_SIZE) ) < 0 ) {
              fprintf(stderr, "server: can't read from the socket.\n");
              exit(1);
           }
           strcpy(&message[6], "Client !\n");
           if ( write(newsockfd, message, len) != len ) {
              fprintf(stderr, "server: can't write into the socket.");
              exit(1);
           }
           exit(0);
        }
        close(newsockfd);           /* This is parent process   */
     }
}

/*
 *     Example of a connection-oriented client using TCP protocol.
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_TCP_PORT     7000
#define SERVER_HOST_ADDR    "128.230.23.8"
#define MAX_MSG_SIZE        2048

char *hello = "Hello Server !\n";

main()
{
     int sockfd, n;
     struct sockaddr_in serv_addr;
     char message[MAX_MSG_SIZE];

     /*
      * Open a TCP socket (an Internet stream socket).
      */

     if ( ( sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0 ) {
        fprintf(stderr, "client: can't open stream socket.");
        exit(1);
     }

     /*
      * Specify the server address to connect.
      */

     bzero((char *) &serv_addr, sizeof(serv_addr));           /* Initialize  */
     serv_addr.sin_family      = AF_INET;                     /* Internet    */
     serv_addr.sin_port        = htons(SERVER_TCP_PORT);      /* Port number */
     serv_addr.sin_addr.s_addr = inet_addr(SERVER_HOST_ADDR); /* Host addr   */

     /*
      * Connect to the server.
      */

     if (connect(sockfd,(struct sockaddr *)&serv_addr,sizeof(serv_addr)) < 0) {
        fprintf(stderr, "client: can't connect to the server.");
        exit(1);
     }

     /*
      * Do a specific task for the client.
      */

     n = strlen(hello);
     if ( write(sockfd, hello, n) != n ) {
        fprintf(stderr, "client: can't write into the socket.\n");
        exit(1);
     }
     if ( ( n = read(sockfd, message, MAX_MSG_SIZE) ) < 0 ) {
        fprintf(stderr, "client: can't read from the socket.\n");
        exit(1);
     }
     message[n] = '\0';
     printf("%s", message);

     /*
      * Close used socket.
      */

     close(sockfd);
     exit(0);
}


/*
 *     Example of a connectionless server using UDP protocol.
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_UDP_PORT     6000
#define MAX_MSG_SIZE        2048

main()
{
     int sockfd, clilen, n;
     struct sockaddr_in  serv_addr, client_addr;
     char message[MAX_MSG_SIZE];

     /*
      * Open a UDP socket (an Internet datagram socket).
      */

     if ( ( sockfd = socket(AF_INET, SOCK_DGRAM, 0) ) < 0 ) {
        fprintf(stderr, "server: can't open datagram socket.\n");
        exit(1);
     }

     /*
      * Bind the local address of server.
      */

     bzero((char *) &serv_addr, sizeof(serv_addr));      /* Initialize      */
     serv_addr.sin_family      = AF_INET;                /* Internet family */
     serv_addr.sin_port        = htons(SERVER_UDP_PORT); /* Port number     */
     serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);      /* Netid / Hostid  */

     if ( bind(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0 ) {
        fprintf(stderr, "server: can't bind local address.\n");
        exit(1);
     }

     /*
      * Wait for data from a client process.
      */

     while ( 1 ) {
        clilen = sizeof(client_addr);
        n = recvfrom(sockfd, message, MAX_MSG_SIZE, 0, 
                    (struct sockaddr *) &client_addr, &clilen);
        if ( n < 0 ) {
           fprintf(stderr, "server: can't receive from.\n");
           exit(1);
        }
        strcpy(&message[6], "Client !\n");
        if ( sendto(sockfd, message, n, 0, 
                   (struct sockaddr *) &client_addr, clilen) != n ) {
           fprintf(stderr, "server: can't send to.\n");
           exit(1);
        }
     }
}


/*
 *     Example of a connectionless client using UDP protocol.
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_UDP_PORT     6000
#define SERVER_HOST_ADDR    "128.230.23.8"
#define MAX_MSG_SIZE        2048

char *hello = "Hello Server !\n";

main()
{
     int sockfd, servlen, n;
     struct sockaddr_in serv_addr, client_addr;
     char message[MAX_MSG_SIZE];

     /*
      * Open a UDP socket (an Internet datagram socket).
      */

     if ( ( sockfd = socket(AF_INET, SOCK_DGRAM, 0) ) < 0 ) {
        fprintf(stderr, "client: can't open datagram socket.\n");
        exit(1);
     }

     /*
      * Bind the local address of this client.
      */

     bzero((char *) &client_addr, sizeof(client_addr));  /* Initialize      */
     client_addr.sin_family      = AF_INET;              /* Internet family */
     client_addr.sin_port        = htons(0);             /* Port number     */
     client_addr.sin_addr.s_addr = htonl(INADDR_ANY);    /* Netid / Hostid  */

     if ( bind(sockfd, (struct sockaddr *) &client_addr,
               sizeof(client_addr)) < 0 ) {
        fprintf(stderr, "client: can't bind local address.\n");
        exit(1);
     }

     /*
      * Specify the server address.
      */

     bzero((char *) &serv_addr, sizeof(serv_addr));           /* Initialize  */
     serv_addr.sin_family      = AF_INET;                     /* Internet    */
     serv_addr.sin_port        = htons(SERVER_UDP_PORT);      /* Port number */
     serv_addr.sin_addr.s_addr = inet_addr(SERVER_HOST_ADDR); /* Host addr   */

     /*
      * Do a specific task for the client.
      */

     servlen = sizeof(serv_addr);
     n = strlen(hello);
     if ( sendto(sockfd, hello, n, 0, 
                (struct sockaddr *) &serv_addr, servlen) != n ) {
        fprintf(stderr, "client: can't send to.\n");
        exit(1);
     }
     if ( (n = recvfrom(sockfd, message, MAX_MSG_SIZE, 0,
                       (struct sockaddr *) &serv_addr, &servlen)) < 0 ) {
        fprintf(stderr, "client: can't receive from.\n");
        exit(1);
     }

     message[n] = '\0';
     printf("%s", message);

     /*
      * Close used socket.
      */

     close(sockfd);
     exit(0);
}

\end{verbatim}


