package sv.config;

import sv.engine.SV2Engine;
import java.awt.Color;

public class Config2D extends Configs {

  /**
   * plot mode
   */
  protected int plotmode = WIREFRAME;

  /**
   * bounding box
   */
  protected boolean boundingbox = true;
  

  /**
   * shpere size for point plot
   */
  protected int sphereSize = 0;

  /**
   * constructor
   */
  public Config2D(SV2Engine eng) {
    super(eng);
    bgColor = new Color(0.05f, 0.05f, 0.2f);
  }

  /**
   * set plot mode
   */
  public void setPlotMode(int m) {
    plotmode = m;
  }

  /**
   * return plot mode
   */
  public int getPlotMode() {
    return plotmode;
  }


  /**
   * return sphere size
   */
  public int getSphereSize() {
    return sphereSize;
  }

  /**
   * set sphere size
   */
  public void setSphereSize(int m) {
    sphereSize = m;
  }

  /**
   * set bounding box mode
   */
  public void setBoungBox(boolean b) {
    boundingbox = b;
  }

  /**
   * return if bounding box will be drawn
   */
  public boolean isBoundingBox() {
    return boundingbox;
  }

  /**
   * return  setting values
   */
  public String[] getConfigs() {
    return null;
  }

  /**
   * set setting values from the arguments
   */
  public void setConfigs(String[] args) {

  }

} // end of class
