package sv.data;

/**
 * define time value to be used
 */

public class TimeValue {

  private float absolute;
  private String strtime;

  /**
   * the time value is float type
   */  
  public TimeValue(float time) {
    absolute = time;
  }

  /**
   * the time value is string type like mm/dd/tt/ss/yy
   */  
  public TimeValue(String time) {
    strtime = time;
  }

  /**
   * return current time converted to absolute value
   */
  public float getAbsTime() {
    return absolute;
  }

  /**
   * return current time data as a form of string
   */
  public String getStrTime() {
    return strtime;  
  }

} // end of class
