package sv.engine;

public class SV2Action {
  // visualization frame event  
  public static final int CLOSE                      = 101;
  public static final int ANIMATE                    = 102;
  public static final int STOP                       = 103;
  public static final int NEXT                       = 104;
  public static final int PREVIOUS                   = 105;
  public static final int ISOVALUE_CHANGE            = 106; 
  public static final int VOLVALUE_CHANGE            = 107; 
  public static final int VOLBULK_REQUEST            = 108; 
  public static final int DISPLAY_TIME               = 109; 
  public static final int GLOBALMINMAX               = 110;
  public static final int COLORMAP_CHANGE            = 111;
  public static final int BACKGROUND_COLOR           = 112;
  public static final int FOREGROUND_COLOR           = 113;
  
  // for 1d only
  public static final int CONNECT_POINT              = 121; 
  public static final int TICKMARKS                  = 122; 
  public static final int DISPLAY_LABEL              = 123; 
  public static final int DISPLAY_LEGEND             = 124; 
  public static final int DISPLAY_BASELINE           = 125; 
  public static final int LEGEND_CHANGE              = 126; 
  public static final int LABEL_CHANGE               = 127; 
  public static final int COLORMODE_CHANGE           = 128; 

  // for common 2d & 3d
  public static final int PLOTMODE_CHANGE            = 141; 
  public static final int BOUNDINGBOX                = 142; 
  public static final int MATERIAL_CHANGE            = 143;

  // for 2d only
  public static final int CONTOUR                    = 161; 

  // for 3d only
  public static final int XGRID_VIEW                 = 181; 
  public static final int YGRID_VIEW                 = 182; 
  public static final int ZGRID_VIEW                 = 183; 
  public static final int GRIDUPDATE                 = 184;
  public static final int DOWNSIZE                   = 185;
  public static final int SMOOTHE                    = 186;
  public static final int DOWNSIZE_SMOOTHE           = 187;
  public static final int VOLUME_RAY_COLOR           = 188;

  // main gui event
  public static final int LARGE_ICON_VIEW            = 201;
  public static final int SMALL_ICON_VIEW            = 202;
  public static final int DETAIL_VIEW                = 203;
  public static final int CUT                        = 204;
  public static final int COPY                       = 205;
  public static final int PASTE                      = 206;
  public static final int DELETE                     = 207;
  public static final int VISUALIZE                  = 208;
  public static final int VIEWIT                     = 209;

} // end of class




