package sv.engine;

public class SV2Protocol {

  // client <---> server protocol
  public static final int REGISTER_CLIENT              = 101;
  public static final int REGISTER_REPLY               = 102;
  public static final int NEW_MASTER                   = 103;
  public static final int CLIENT_EXIT                  = 104;
  public static final int HEAD_DATA_FEED               = 105;
  public static final int SERVER_DATA_WORK             = 106;
  public static final int BROADCAST_COMMAND            = 107;
  public static final int COOKED_DATA_FEED             = 108;
  public static final int VOLUME_IMAGE_FEED            = 109;	
  public static final int VOLUME_IMAGE_BULK            = 110;
  public static final int SERVER_FILTER_WORK           = 111;
  public static final int CLIENT_FILTER_WORK           = 112;
  public static final int CACHE_TRANSFER               = 113;

  public static final int ACCESS_DENIED                = 198;
  public static final int PROTOCOL_ERROR               = 199;
						  
  // simulator <---> server protocol		  
  public static final int RAW_DATA_FEED                = 201;
  public static final int DEN_DATA_FEED                = 202;
						  
  // console <---> server protocol		  
  public static final int KILL_SERVER                  = 666;

} // end of class 
