package sv.gui;

import java.awt.*;
import com.sun.java.swing.border.*;

public class Borders {

    public final static Border emptyBorder0 = new EmptyBorder(0,0,0,0);
    public final static Border emptyBorder5 = new EmptyBorder(5,5,5,5);
    public final static Border emptyBorder10 = new EmptyBorder(10,10,10,10);
    public final static Border emptyBorder15 = new EmptyBorder(15,15,15,15);
    public final static Border emptyBorder20 = new EmptyBorder(20,20,20,20);

    public final static Border etchedBorder0 
               = new CompoundBorder(new EtchedBorder(), emptyBorder0);
    public final static Border etchedBorder5 
               = new CompoundBorder(new EtchedBorder(), emptyBorder5);
    public final static Border etchedBorder10 
               = new CompoundBorder(new EtchedBorder(), emptyBorder10);
    public final static Border raisedBorder 
               = new BevelBorder(BevelBorder.RAISED);
    public final static Border lightLoweredBorder 
               = new BevelBorder(BevelBorder.LOWERED, Color.white, Color.gray);
    public final static Border loweredBorder 
               = new SoftBevelBorder(BevelBorder.LOWERED);
    public final static Border systemBorder 
               = new CompoundBorder(emptyBorder5, etchedBorder5);


} // end of class
