package sv.gui;

import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

public class StatusBar extends JPanel {

  private Label label;
  
  public StatusBar() {
     label = new Label();

     setLayout(new BorderLayout());
     setBorder(Borders.lightLoweredBorder);
     add("Center", label);
  }  

  /**
   * display the message
   * @param msg message to be displayed
   * @param critical if true, display will be red
   */
  public void display(String msg, boolean critical) {
     if (critical)  label.setForeground(Color.red);
     else           label.setForeground(Color.black);

     label.setText(msg);
  }

} // end of class





